
// MFCApplication1Dlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "MFCApplication1.h"
#include "MFCApplication1Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CMFCApplication1Dlg dialog



CMFCApplication1Dlg::CMFCApplication1Dlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MFCAPPLICATION1_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCApplication1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_VIDEOCAPCTRL1, m_VideoCap);
	DDX_Control(pDX, IDC_CBOVIDEODEVICE, m_CboVideoDevice);
	DDX_Control(pDX, IDC_CBOVIDEOFORMAT, m_CboVideoFormat);
}

BEGIN_MESSAGE_MAP(CMFCApplication1Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CMFCApplication1Dlg::OnBnClickedButton1)
	ON_CBN_SELCHANGE(IDC_CBOVIDEODEVICE, &CMFCApplication1Dlg::OnSelchangeCbovideodevice)
END_MESSAGE_MAP()


// CMFCApplication1Dlg message handlers

//BOOL CMFCApplication1Dlg::OnInitDialog()
//{
//	CDialogEx::OnInitDialog();
//
//	// Add "About..." menu item to system menu.
//
//	// IDM_ABOUTBOX must be in the system command range.
//	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
//	ASSERT(IDM_ABOUTBOX < 0xF000);
//
//	CMenu* pSysMenu = GetSystemMenu(FALSE);
//	if (pSysMenu != nullptr)
//	{
//		BOOL bNameValid;
//		CString strAboutMenu;
//		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
//		ASSERT(bNameValid);
//		if (!strAboutMenu.IsEmpty())
//		{
//			pSysMenu->AppendMenu(MF_SEPARATOR);
//			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
//		}
//	}
//
//	// Set the icon for this dialog.  The framework does this automatically
//	//  when the application's main window is not a dialog
//	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
//
//	// TODO: Add extra initialization here
//
//	return TRUE;  // return TRUE  unless you set the focus to a control
//}

void CMFCApplication1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCApplication1Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCApplication1Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CMFCApplication1Dlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	int iDeviceIndex = m_CboVideoDevice.GetCurSel();
	int iVideoFormatIndex = m_CboVideoFormat.GetCurSel();

	if (iDeviceIndex != -1)
		m_VideoCap.SetDevice(iDeviceIndex);

	if (iVideoFormatIndex != -1)
		m_VideoCap.SetVideoFormat(iVideoFormatIndex);

	m_VideoCap.Start();
}


BOOL CMFCApplication1Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	int iDeviceCount = m_VideoCap.GetDevices().GetCount();
	CString strDeviceName;
	for (int i = 0; i < iDeviceCount; i++)
	{

		strDeviceName = m_VideoCap.GetDevices().FindDeviceName(i);
		m_CboVideoDevice.AddString(strDeviceName);
	}

	if (m_CboVideoDevice.GetCount() > 0)
		m_CboVideoDevice.SetCurSel(0);

	////////////////////video format
	int iVideoFormatCount = m_VideoCap.GetVideoFormats().GetCount();

	CString strVideoFormat;

	for (int i = 0; i < iVideoFormatCount; i++)
	{
		strVideoFormat = m_VideoCap.GetVideoFormats().FindVideoFormatName(i);
		m_CboVideoFormat.AddString(strVideoFormat);
	}

	if (m_CboVideoFormat.GetCount() > 0)
		m_CboVideoFormat.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}


void CMFCApplication1Dlg::OnSelchangeCbovideodevice()
{
	// TODO: Add your control notification handler code here
	int iVideoFormatCount = m_CboVideoFormat.GetCount();
	for (int i = 0; i < iVideoFormatCount; i++)
		m_CboVideoFormat.DeleteString(0);

	m_VideoCap.RefreshVideoDevice(m_CboVideoDevice.GetCurSel());

	iVideoFormatCount = m_VideoCap.GetVideoFormats().GetCount();
	CString strVideoFormat;
	for (int i = 0; i < iVideoFormatCount; i++)
	{
		strVideoFormat = m_VideoCap.GetVideoFormats().FindVideoFormatName(i);
		m_CboVideoFormat.AddString(strVideoFormat);
	}

	if (m_CboVideoFormat.GetCount() > 0)
		m_CboVideoFormat.SetCurSel(0);
}
